/* Diese Klasse soll zwei Objekte a und b in das Objekt c kopieren
 * Dabei soll die Kopie sich so verhalten, dass eine nderung in
 * c nicht a bzw. b beeinflusst.
 * Die Kopie von a erfllt dies nicht, die von b schon.
 * Autor: Ren Thiemann
 * Erstellt: 17.11.2003
 * Letzte nderung: 19.11.2003
 */
public class Referenz2 {

    public int wert; // dies ist der Wert des Objekts,
                     // der nicht beeinflusst werden soll
    

    public static void main(String[] args) {
	
	Referenz2 a = new Referenz2();
	a.wert = 1;

	Referenz2 b = new Referenz2();
	b.wert = 2;

	Referenz2 c;
	
	System.out.println(a);
	System.out.println(b);	
	System.out.println();

	// nur Referenz wird kopiert
	// keine Kopie der Inhalte!

	c = a;

	System.out.println(a);
	System.out.println(c);	
	System.out.println();
	
	
	// Aenderung auch in a!
	c.wert = 13;

	System.out.println(a);
	System.out.println(c);	
	System.out.println();
	
	// Jetzt wird eine Kopie genutzt
	c = b.erstelleKopie();

	System.out.println(b);
	System.out.println(c);	
	System.out.println();

	// Aenderung an c beeinflusst nicht mehr b
	c.wert = 13;

	System.out.println(b);
	System.out.println(c);	
	System.out.println();
	

    }

    // hier wird eine Kopie erstellt
    public Referenz2 erstelleKopie() {
	// erstelle ein neues Objekt
	Referenz2 kopie = new Referenz2();
	// kopiere den Wert vom Original(this) in die Kopie
	kopie.wert = this.wert;
	return kopie;
    }
    
    // fuer die Ausgabe
    public String toString() {
	return ("Objekt mit Wert "+Integer.toString(wert));
    }
}
