/* Diese Klasse soll zwei Arrays a und b in das Array c kopieren
 * Dabei soll die Kopie sich so verhalten, dass eine nderung in
 * c nicht a bzw. b beeinflusst.
 * Die Kopie von a erfllt dies nicht, die von b schon.
 * Autor: Ren Thiemann
 * Erstellt: 17.11.2003
 * Letzte nderung: 19.11.2003
 */
public class Referenz3 {
    
    public static void main(String[] args) {
	
	Referenz2 r1 = new Referenz2();
	r1.wert = 1;
	Referenz2 r2 = new Referenz2();
	r2.wert = 2;
	Referenz2 r3 = new Referenz2();
	r3.wert = 3;
	Referenz2 r4 = new Referenz2();
	r4.wert = 4;
	Referenz2 r13 = new Referenz2();
	r13.wert = 13;

	Referenz2[] a = {r1,r2};
	Referenz2[] b = {r3,r4};
	Referenz2[] c;
	
	IO.printArray(a);
	IO.printArray(b);
	System.out.println();
	
	
	// alle Eintraege kopieren (Shallow Copy)
	c = new Referenz2[a.length];
	for (int i=0; i < a.length; i++) {
	    c[i] = a[i];
	}

	IO.printArray(a);
	IO.printArray(c);
	System.out.println();
	
	
	// Aenderung der Tabelleneintraege in c beeinflusst nicht mehr a
	c[1] = r13;
	
	IO.printArray(a);
	IO.printArray(c);
	System.out.println();
	
	// Aber Aenderung der Elemente im Array hat Einfluss
	c[0].wert = 13*13;

	IO.printArray(a);
	IO.printArray(c);
	System.out.println();
	
	// fuer alle Eintraege Kopie erstellen (Deep Copy)
	c = new Referenz2[a.length];
	for (int i=0; i < a.length; i++) {
	    c[i] = b[i].erstelleKopie();
	}

	// Aenderung der Tabelleneintraege in c beeinflusst nicht mehr a
	c[1] = r13;

	IO.printArray(b);
	IO.printArray(c);
	System.out.println();

	// auch Aenderung der Elemente im Array hat Einfluss
	c[0].wert = 13*13;

	IO.printArray(b);
	IO.printArray(c);
	

	// Falls jedoch in Referenz2 auch nicht primitive Datentypen gespeichert
	// werden, so muessen auch diese in der entsprechenden Methode
	// "erstelleKopie" kopiert werden, wenn komplette Kopie erwuenscht wird!
	// Diese Art der Kopie nennt man "Deep Copy" im Gegensatz zur "Shallow Copy"
	
    }
 
}
