/* Diese Klasse dreht diverse Arrays um
 * Durch Verwendung von Methoden ergibt sich ein modularer Code
 * Autor: Ren Thiemann
 * Erstellt: 17.11.2003
 * Letzte nderung: 19.11.2003
 */


public class ReverseGood {

    // dreht das Array um (destruktiv)
    public static void reverse(int[] array) {
	int i = 0;
	while (i < array.length / 2) {
	    int swap = array[array.length-1-i];
	    array[array.length-1-i] = array[i];
	    array[i] = swap;
	    i++;
	}
    }
    
    // nicht destruktives umdrehen
    // das umgedrehte Array wird zurueckgegeben
    public static int[] reverseNonDestructive(int[] array) {
	int i = 0;
	int[] newArray = new int[array.length];
	while (i < array.length) {
	    newArray[i] = array[array.length-1-i];
	    i++;
	}
	return newArray;
    }

    public static void main(String[] args) {

	// arrays anlegen
	int[] array1 = {1,2,3,4,5};
	int[] array2 = {6,7,8,9,0};
	int[][] arrays = new int[10][];
	for (int j = 0; j < 10; j++) {
	    arrays[j] = new int[10];
	    for (int k = 0; k < 10; k++) {
		arrays[j][k] = j*10+k;
	    }
	}


	int i;

	IO.printIntArray(array1);
	IO.printIntArray(array2);
	System.out.println();

	// 1. array umdrehen
	
	reverse(array1);
	// oder array1 = reverseNonDestructive(array1);

	// 2. array umdrehen

	reverse(array2);
	
	IO.printIntArray(array1);
	IO.printIntArray(array2);
	System.out.println("\n\n");


	// 3. alle arrays umdrehen

	IO.printIntMatrix(arrays);
	System.out.println();

	for (int j = 0; j < 10; j++) {
	    reverse(arrays[j]);
	}

	IO.printIntMatrix(arrays);
	
    }
}
