/* Diese Klasse dient zur Ausgabe mehrerer Texte auf demselben Medium
 * Jeder TextPrinter hat einen eigenen Text, den er ausgeben soll,
 * Fuer das gemeinsame Medium wird global, durch statische Attribute,
 * gespeichert, wieviel Platz noch auf der Seite ist, welche Nummer die
 * aktuelle Seite hat und wieviel Platz generell auf eine Seite passt.
 *
 * Zur Verdeutlichung der statischen und nicht-statischen Attribute/Methoden
 * wurde hier jeweils ein "this." oder ein "TextPrinter." hinzugefuegt
 *
 * Autor: Ren Thiemann
 * Erstellt: 17.11.2003
 * Letzte nderung: 19.11.2003
 */
public class TextPrinter {

    public static int pageSize = 20;
    public static int pageCount = 1;
    public static int lineCount = 0;

    public int currentLine = 0;
    public String[] text;
    public String id;

    // gebe den Seitenabschluss aus
    public static void printFooter() {
	System.out.println();
	System.out.println("          Seite Nr. "+TextPrinter.pageCount);
	System.out.println();
	IO.readLine();
	TextPrinter.pageCount++;
	TextPrinter.lineCount = 0;
    }

    // setze eine neue Seitengroesse fest
    // und beende dadurch auch eine angefangene Seite
    public static void setNewPageSize(int size) {
	// Abschluss der angebrochenen Seite
	if (TextPrinter.lineCount > 0) {
	    TextPrinter.printFooter();
	}

	// Setzen des neuen Wertes
	TextPrinter.pageSize = size;
	System.out.println("(Ausgabe auf "+TextPrinter.pageSize+" Zeilen)");
    }
	
    // ueberpruefe, ob der aktuelle Text schon ausgegeben wurde
    public boolean finished() {
	return (this.currentLine == this.text.length);
    }

    // gebe die naechste Zeile aus
    public void outputNextLine() {
	// Test auf Seitenende
	if (TextPrinter.lineCount == TextPrinter.pageSize) {
	    TextPrinter.printFooter();
	}
	// Ausgabe der Zeile
	System.out.println(this.id+": "+this.text[this.currentLine]);
	TextPrinter.lineCount++;
	this.currentLine++;
    }

    // gebe den Rest des Textes aus
    public void outputRest() {
	while (!this.finished()) {
	    this.outputNextLine();
	}
    }

    // speichere den Text mit einem Identifier ab
    public void setTextAndId(String[] text, String id) {
	this.text = text;
	this.id   = id;
    }

    // ein kleiner Testlauf
    public static void main(String[] args) {
	TextPrinter.setNewPageSize(10);
	
	TextPrinter t1 = new TextPrinter();
	t1.setTextAndId(IO.readFile("Caesar.java"),"1");
	TextPrinter t2 = new TextPrinter();
	t2.setTextAndId(IO.readFile("XGewinnt.java"),"2");
	while (!t1.finished()) {
	    t1.outputNextLine();
	    if (!t1.finished()) {
		t1.outputNextLine();
	    }
	    t2.outputNextLine();
	}

	TextPrinter.setNewPageSize(20);
	
	t2.outputRest();
	
	TextPrinter.printFooter();
    }
}
