/* Diese Klasse dient zur Ausgabe mehrerer Texte auf demselben Medium
 * Jeder TextPrinter hat einen eigenen Text, den er ausgeben soll,
 * Fuer das gemeinsame Medium wird global, durch statische Attribute,
 * gespeichert, wieviel Platz noch auf der Seite ist, welche Nummer die
 * aktuelle Seite hat und wieviel Platz generell auf eine Seite passt.
 *
 * Diese Klasse ist fast identisch zu TextPrinter2.java bis auf die
 * Tatsache, das hier alle "static" bis auf das der main-Methode 
 * geloescht wurden. Die Ausfuehrung des Programms zeigt deutlich,
 * das dadurch ein komplett falsches Ergebnis entsteht.
 * zudem mussten in der main-Methode drei Aufrufe auskommentiert werden,
 * da diese zu Kompilationsproblemen fuehren. (Da man keine nicht-statischen
 * Methoden ohne Objekt aufrufen kann)
 *
 * Autor: Ren Thiemann
 * Erstellt: 17.11.2003
 * Letzte nderung: 19.11.2003
 */
public class TextPrinter3 {

    public int pageSize = 20;
    public int pageCount = 1;
    public int lineCount = 0;

    public int currentLine = 0;
    public String[] text;
    public String id;

    // gebe den Seitenabschluss aus
    public void printFooter() {
	System.out.println();
	System.out.println("          Seite Nr. "+pageCount);
	System.out.println();
	IO.readLine();
	pageCount++;
	lineCount = 0;
    }

    // setze eine neue Seitengroesse fest
    // und beende dadurch auch eine angefangene Seite
    public void setNewPageSize(int size) {
	// Abschluss der angebrochenen Seite
	if (lineCount > 0) {
	    printFooter();
	}

	// Setzen des neuen Wertes
	pageSize = size;
	System.out.println("(Ausgabe auf "+pageSize+" Zeilen)");
    }
	
    // ueberpruefe, ob der aktuelle Text schon ausgegeben wurde
    public boolean finished() {
	return (currentLine == text.length);
    }

    // gebe die naechste Zeile aus
    public void outputNextLine() {
	// Test auf Seitenende
	if (lineCount == pageSize) {
	    printFooter();
	}
	// Ausgabe der Zeile
	System.out.println(lineCount+"/"+currentLine+"/"+id+": "+text[currentLine]);
	lineCount++;
	currentLine++;
    }

    // gebe den Rest des Textes aus
    public void outputRest() {
	while (!finished()) {
	    outputNextLine();
	}
    }

    // speichere den Text mit einem Identifier ab
    public void setTextAndId(String[] text, String id) {
	this.text = text;
	this.id   = id;
    }

    // ein kleiner Testlauf
    public static void main(String[] args) {
	// setNewPageSize(10);
	
	TextPrinter3 t1 = new TextPrinter3();
	t1.setTextAndId(IO.readFile("Caesar.java"),"1");
	TextPrinter3 t2 = new TextPrinter3();
	t2.setTextAndId(IO.readFile("XGewinnt.java"),"2");
	while (!t1.finished()) {
	    t1.outputNextLine();
	    if (!t1.finished()) {
		t1.outputNextLine();
	    }
	    t2.outputNextLine();
	}

	// setNewPageSize(20);
	
	t2.outputRest();
	
	// printFooter();
    }
}
