/* Diese Klasse dient zur Ausgabe mehrerer Texte auf demselben Medium
 * Jeder TextPrinter hat einen eigenen Text, den er ausgeben soll,
 * Fuer das gemeinsame Medium wird global, durch statische Attribute,
 * gespeichert, wieviel Platz noch auf der Seite ist, welche Nummer die
 * aktuelle Seite hat und wieviel Platz generell auf eine Seite passt.
 *
 * Diese Klasse ist fast identisch zu TextPrinter.java bis auf die
 * Tatsache, das hier alles als statisch deklariert wurde (und ein
 * paar kleine Veraenderung in setWertAndId). Wie in TextPrinter3
 * fuehrt dies bei der Ausfuehrung zu nicht erwuenschtem Verhalten.
 *
 * Autor: Ren Thiemann
 * Erstellt: 17.11.2003
 * Letzte nderung: 19.11.2003
 */
public class TextPrinter4 {

    public static int pageSize = 20;
    public static int pageCount = 1;
    public static int lineCount = 0;

    public static int currentLine = 0;
    public static String[] text;
    public static String id;

    // gebe den Seitenabschluss aus
    public static void printFooter() {
	System.out.println();
	System.out.println("          Seite Nr. "+pageCount);
	System.out.println();
	IO.readLine();
	pageCount++;
	lineCount = 0;
    }

    // setze eine neue Seitengroesse fest
    // und beende dadurch auch eine angefangene Seite
    public static void setNewPageSize(int size) {
	// Abschluss der angebrochenen Seite
	if (lineCount > 0) {
	    printFooter();
	}

	// Setzen des neuen Wertes
	pageSize = size;
	System.out.println("(Ausgabe auf "+pageSize+" Zeilen)");
    }
	
    // ueberpruefe, ob der aktuelle Text schon ausgegeben wurde
    public static boolean finished() {
	return (currentLine == text.length);
    }

    // gebe die naechste Zeile aus
    public static void outputNextLine() {
	// Test auf Seitenende
	if (lineCount == pageSize) {
	    printFooter();
	}
	// Ausgabe der Zeile
	System.out.println(lineCount+"/"+currentLine+"/"+id+": "+text[currentLine]);
	lineCount++;
	currentLine++;
    }

    // gebe den Rest des Textes aus
    public static void outputRest() {
	while (!finished()) {
	    outputNextLine();
	}
    }

    // speichere den Text mit einem Identifier ab
    public static void setTextAndId(String[] txt, String ident) {
	text = txt;
	id   = ident;
    }

    // ein kleiner Testlauf
    public static void main(String[] args) {
	setNewPageSize(10);
	
	TextPrinter4 t1 = new TextPrinter4();
	t1.setTextAndId(IO.readFile("Caesar.java"),"1");
	TextPrinter4 t2 = new TextPrinter4();
	t2.setTextAndId(IO.readFile("XGewinnt.java"),"2");
	while (!t1.finished()) {
	    t1.outputNextLine();
	    if (!t1.finished()) {
		t1.outputNextLine();
	    }
	    if (!t2.finished()) {
		t2.outputNextLine();
	    }
	}

	setNewPageSize(20);
	
	t2.outputRest();
	
	printFooter();
    }
}
