/*
 * x-Gewinnt: Ein kleines Spiel fuer Zwischendurch
 * Regelwerk: siehe 4-gewinnt
 * Autor: Rene Thiemann
 * Erstellt: 6.11.2003
 * Letzte Aenderung: 19.11.2003
 */

public class XGewinnt {

    // startet das Spiel
    public static void main(String args) {

	// einlesen der Spielparameter
	System.out.print("Anzahl Zeilen: ");
	int zeilen = IO.readInt();
	System.out.print("Anzahl Spalten: ");
	int spalten = IO.readInt();
	System.out.print("x: ");
	int xgewinnt = IO.readInt();
	if (zeilen <= 0 || spalten <= 0 || xgewinnt <=0) {
	    System.out.println("Fehlerhafte Spielparameter, nehme Standard-Werte");
	    
	    zeilen = 6;
	    spalten = 7;
	    xgewinnt = 4;
	}

	// aufbau des spielfelds
	int spiel[][] = new int[zeilen][spalten];
	for (int i=0; i < zeilen; i++) {
	    for (int j=0; j < spalten; j++) {
		spiel[i][j] = 0;
	    }
	}
	// so ab hier gibts die Musterloesung erst wieder ab Freitag
        // ich habe hier mal ein wenig den TextPrinter eingesetzt

        // Viel Spass beim Vorrechnen, Rene 
    }
    
    public static int pageSize = 20;
    public static int pageCount = 1;
    public static int lineCount = 0;

    public int currentLine = 0;
    public String[] text;
    public String id;

    // gebe den Seitenabschluss aus
    public static void printFooter() {
	System.out.println();
	System.out.println("          Seite Nr. "+pageCount);
	System.out.println();
	IO.readLine();
	pageCount++;
	lineCount = 0;
    }

    // setze eine neue Seitengroesse fest
    // und beende dadurch auch eine angefangene Seite
    public static void setNewPageSize(int size) {
	// Abschluss der angebrochenen Seite
	if (lineCount > 0) {
	    printFooter();
	}

	// Setzen des neuen Wertes
	pageSize = size;
	System.out.println("(Ausgabe auf "+pageSize+" Zeilen)");
    }
	
    // ueberpruefe, ob der aktuelle Text schon ausgegeben wurde
    public boolean finished() {
	return (currentLine == text.length);
    }

    // gebe die naechste Zeile aus
    public void outputNextLine() {
	// Test auf Seitenende
	if (lineCount == pageSize) {
	    printFooter();
	}
	// Ausgabe der Zeile
	System.out.println(lineCount+"/"+currentLine+"/"+id+": "+text[currentLine]);
	lineCount++;
	currentLine++;
    }

    // gebe den Rest des Textes aus
    public void outputRest() {
	while (!finished()) {
	    outputNextLine();
	}
    }

    // speichere den Text mit einem Identifier ab
    public void setTextAndId(String[] text, String id) {
	this.text = text;
	this.id   = id;
    }

    // ein kleiner Testlauf
    public static void main(String[] args) {
	setNewPageSize(10);
	
	TextPrinter2 t1 = new TextPrinter2();
	t1.setTextAndId(IO.readFile("Caesar.java"),"1");
	TextPrinter2 t2 = new TextPrinter2();
	t2.setTextAndId(IO.readFile("XGewinnt.java"),"2");
	while (!t1.finished()) {
	    t1.outputNextLine();
	    if (!t1.finished()) {
		t1.outputNextLine();
	    }
	    t2.outputNextLine();
	}

	setNewPageSize(20);
	
	t2.outputRest();
	
	printFooter();
    }

}
